# Contributing to Norse

Issues, suggested changes and comments of any kind are welcome. This document serves to make it as painless as possible to contribute by explaining how your contribution are included as fast as possible.

## Asking questions or getting in touch

If you would simply like to get in touch with us, please contact us via email:
* C. Pehle `<christian.pehle@kip.uni-heidelberg.de>`
* J. Pedersen `<jeped@kth.se>`

## Submitting bugs

Bug reports are most welcome, but please be as specific and constructive as possible. As a minimum you should include 
* *What* the problem is, stated briefly
* *How* it happened, and how it can be reproduced
* *Why* this is a problem
  * This might not be clear to someone else than you. The clearer you can make it, the faster it will be understood and fixed

## Contributing code

Assuming you have a feature you would like to implement, we recommend the following steps:
1. Fork the repository
2. Implement your feature
3. Make sure the feature is tested using [pytest](https://pytest.org/en/latest/) and that your test *passes*
4. Push the code to your fork and submit a pull request, possibly with a link to any issues of relevance
5. React to any feedback we give around the fork. We might ask you to fix minor issues before merging it with the main branch.

We will try to get around to your contributions as fast as possible. And thank you for taking the time to improve the code!